#! /usr/bin/env python
###############################################################################
#
# Copyright (C) 2015
# ASTRON (Netherlands Institute for Radio Astronomy) <http://www.astron.nl/>
# P.O.Box 2, 7990 AA Dwingeloo, The Netherlands
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Purpose:
# . Read the diag data buffers at the correlator input stage and display info
# Description:
# . Reads the data buffers in 

import test_case
import node_io
import pi_diag_data_buffer
from common import *

NOF_STREAMS = 12 # 3x10G * 4 substreams (BF units)
NOF_WORDS_PER_BUFFER = 256
NOF_WORDS_PER_FRAME = 176

tc = test_case.Testcase('TC - ', '')
tc.set_result('PASSED')
io = node_io.NodeIO(tc.nodeImages, tc.base_ip)
db = pi_diag_data_buffer.PiDiagDataBuffer(tc, io, nofStreams=NOF_STREAMS, ramSizePerStream=NOF_WORDS_PER_BUFFER)

# Read the 12 data buffers per targeted FPGA
dat_nodes = []
for node in tc.nodeNrs:
    dat_node = []
    for stream in range(NOF_STREAMS):
        dat_node.append( db.read_data_buffer(streamNr=stream, n=NOF_WORDS_PER_FRAME, radix='hex', width=16, nodeNr=[node])[0] )
    dat_nodes.append(dat_node)

# Do something with the collected data
