#! /usr/bin/env python
###############################################################################
#                                                                             
# Copyright (C) 2014
# ASTRON (Netherlands Institute for Radio Astronomy) <http://www.astron.nl/>
# P.O.Box 2, 7990 AA Dwingeloo, The Netherlands
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################
from pi_dp_offload_tx_hdr_dat import *
import os

VHDL_SRC_FILE  = '../../src/vhdl/compaan_unb1_dp_offload.vhd'
VHDL_SRC_CONST = 'c_hdr_field_arr'
REGMAP = extract_regmap_from_vhd(VHDL_SRC_FILE, VHDL_SRC_CONST)

class PiDpOffloadTxHdrDatCompaan(PiDpOffloadTxHdrDat):
    def __init__(self, tc, io, inst_name='', nof_inst=None, node_nrs=None, regmap=None):
        PiDpOffloadTxHdrDat.__init__(self, tc, io, inst_name, nof_inst, node_nrs, REGMAP)

#-------------------------------------------------------------------------------
# On execution:
#-------------------------------------------------------------------------------
if __name__ == '__main__':
    on_execute(class_definition=PiDpOffloadTxHdrDatCompaan,regmap=REGMAP)
