 -- COPYRIGHT NOTICE (NOT TO BE REMOVED):
 --
 -- This file, or parts of it, or modified versions of it, may not be
 -- copied, reproduced or transmitted in any form, including
 -- reprinting, translation, photocopying or microfilming, or by any
 -- means, electronic, mechanical or otherwise, or stored in a
 -- retrieval system, or used for any purpose, without the prior
 -- written permission of all Owners unless it is explicitly marked as
 -- having Classification `Public'.
 --
 -- Classification: Restricted.
 --
 -- Owners of this file give notice:
 -- (c) Copyright 2005 - 2009 Compaan Design bv, The Netherlands
 -- All rights, including copyrights, reserved.
 --
 -- This file contains or may contain restricted information and is
 -- UNPUBLISHED PROPRIETARY SOURCE CODE OF THE Owners. The Copyright
 -- Notice(s) above do not evidence any actual or intended publication
 -- of such source code. This file is additionally subject to the
 -- conditions listed in the RESTRICTIONS file and is with NO WARRANTY.
 --
 -- END OF COPYRIGHT NOTICE
 --

library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity write_demux is
   generic(
      N_PORTS : natural := 1
   );
   port(
      WRITES   : out std_logic_vector(N_PORTS-1 downto 0);
      WRITE    : in  std_logic;

      FULLS    : in  std_logic_vector(N_PORTS-1 downto 0);
      FULL     : out std_logic;
      
      WRITE_EN : in  std_logic;
      WRITE_ST : out std_logic;

      CONTROL  : in  std_logic_vector(N_PORTS-1 downto 0)
   );
end write_demux;


architecture RTL of write_demux is

   signal sl_full  : std_logic;
   signal sl_write : std_logic;

begin
   --
   GEN : for i in 0 to N_PORTS-1 generate
      WRITES(i)   <= CONTROL(i) and sl_write;
   end generate;
   --
   process(CONTROL,FULLS)
      variable a : std_logic;
      variable b : std_logic;
   begin
      a := '0';
      for i in 0 to N_PORTS-1 loop
         a := a or ( CONTROL(i) and FULLS(i) );
      end loop;
      sl_full <= a; 
   end process;
   --
   sl_write <=      WRITE_EN and WRITE;
   FULL     <= (not WRITE_EN) or sl_full;
   WRITE_ST <= not sl_full and sl_write;
   --
end RTL;
