-- Execute Unit automatically generated by KpnMapper
-- Function "compaan_outlinedproc1"

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

use work.hw_node_pkg.all;

entity ipcore2RTL_EXECUTION_UNIT_hwn_nd_3 is
   generic (
      N_INPORTS  : natural := 1;
      N_OUTPORTS : natural := 1;
      IP_RESET   : natural := 1; 
      QUANT      : natural := 32;
      c_STAGES   : natural := 1;
      N_CNTRS    : natural := 1; 
      CNTR_QUANT : natural := 32; 
      CNTR_WIDTH : t_counter_width := ( 0=>10, 1=>10, 2=>9, others=>10 ) 
   );
   port (
      RST        : in  std_logic;
      CLK        : in  std_logic;
      -- Funtion Input parameters
      IN_PORT_0    : in  std_logic_vector(31 downto 0);  -- Param. "tmp1"
      READ       : out std_logic_vector(N_INPORTS-1 downto 0);
      EXIST      : in  std_logic_vector(N_INPORTS-1 downto 0);
      -- Iterators
      REG_CNTRS_RD : in  std_logic_vector(N_CNTRS*CNTR_QUANT-1 downto 0);
      -- Funtion Output parameters
      OUT_PORT_0   : out std_logic_vector(31 downto 0);  -- Param. "tmp0"
      WRITE      : out std_logic_vector(N_OUTPORTS-1 downto 0);
      FULL       : in  std_logic_vector(N_OUTPORTS-1 downto 0);
      STOP_RD    : in  std_logic;
      STOP_WR    : in  std_logic;
      ERROR      : out std_logic
   );
end ipcore2RTL_EXECUTION_UNIT_hwn_nd_3 ;

-- Laura implementation
architecture Laura of ipcore2RTL_EXECUTION_UNIT_hwn_nd_3 is

   component compaan_outlinedproc1 is
      generic (
         c_STAGES   : natural := 1;
         N_CNTRS    : natural := 1; 
         CNTR_QUANT : natural := 32; 
         CNTR_WIDTH : t_counter_width := ( 0=>10, 1=>10, 2=>9, others=>10 ) 
      );
      port (
         RST   : in std_logic;
         CLK   : in std_logic;
         -- Inputs 
         ip_tmp1  : in  std_logic_vector(31 downto 0);  
         -- Iterators 
         it_x : in  std_logic_vector(CNTR_WIDTH(0)-1 downto 0);
         EXIST : in  std_logic_vector(0 downto 0);
         READF : out std_logic_vector(0 downto 0);
         -- Outputs 
         op_tmp0 : out std_logic_vector(31 downto 0);
         FULL  : in  std_logic_vector(0 downto 0);
         WRITEF: out std_logic_vector(0 downto 0);
         --
         STOP_RD : in  std_logic;
         STOP_WR : in  std_logic;
         ERROR   : out std_logic
      );
   end component;

   signal sl_RST : std_logic;

begin

   sl_RST <= RST when IP_RESET=1 else not RST;

   FUNC : compaan_outlinedproc1
   generic map (
         c_STAGES      => c_STAGES,
         N_CNTRS       => N_CNTRS,
         CNTR_QUANT    => CNTR_QUANT,
         CNTR_WIDTH    => CNTR_WIDTH
   )
   port map (
      RST   => sl_RST,
      CLK   => CLK,
      -- Inputs 
      ip_tmp1 => IN_PORT_0,
      -- Iterators 
      it_x => REG_CNTRS_RD(0*CNTR_QUANT+CNTR_WIDTH(0)-1 downto 0*CNTR_QUANT),
      EXIST => EXIST,
      READF => READ,
      -- Outputs 
      op_tmp0 => OUT_PORT_0,
      FULL  => FULL,
      WRITEF=> WRITE,
      -- 
      STOP_RD => STOP_RD,
      STOP_WR => STOP_WR,
      ERROR   => ERROR
   );

end Laura;
