-------------------------------------------------------------------------------
-- ipcore2RTL_control_if_ip_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity ipcore2RTL_control_if_ip_wrapper is
  port (
    PARAM_DT : out std_logic_vector(31 downto 0);
    PARAM_LD : out std_logic;
    PARAMETERS_IN : in std_logic_vector(31 downto 0);
    PARAMETERS_IN_LD : in std_logic;
    RST : in std_logic;
    CLK : in std_logic
  );
  
  
end ipcore2RTL_control_if_ip_wrapper;

architecture STRUCTURE of ipcore2RTL_control_if_ip_wrapper is

  component control_if is
	generic (
		RESET_HIGH : NATURAL := 1;
		QUANT : NATURAL := 32
	);
	port (
		PARAM_DT : out std_logic_vector(31 downto 0);
		PARAM_LD : out std_logic;
		PARAMETERS_IN : in std_logic_vector(31 downto 0);
		PARAMETERS_IN_LD : in std_logic;
		RST : in std_logic;
		CLK : in std_logic
	);
end component;

begin

ipcore2RTL_control_if_ip_wrapper_ip : control_if
	generic map (
		RESET_HIGH => 1,
		QUANT => 32
	)
    port map (
		PARAM_DT => PARAM_DT,
		PARAM_LD => PARAM_LD,
		PARAMETERS_IN => PARAMETERS_IN,
		PARAMETERS_IN_LD => PARAMETERS_IN_LD,
		RST => RST,
		CLK => CLK
    );
  
end architecture STRUCTURE;
