--------------------------------------------------------------------------------
--
-- Copyright (C) 2014
-- ASTRON (Netherlands Institute for Radio Astronomy) <http://www.astron.nl/>
-- P.O.Box 2, 7990 AA Dwingeloo, The Netherlands
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
--------------------------------------------------------------------------------

-- u_inst_mmm_unb1_terminal_bg_mesh_db : ENTITY work.mmm_unb1_terminal_bg_mesh_db
--   GENERIC MAP(
--     g_sim         => g_sim,
--     g_sim_unb_nr  => g_sim_unb_nr,
--     g_sim_node_nr => g_sim_node_nr
--   )
--   PORT MAP(
--     mm_clk                      =>  mm_clk,
--     mm_rst                      =>  mm_rst,
--     pout_wdi                    =>  pout_wdi,
--     reg_wdi_mosi                =>  reg_wdi_mosi,
--     reg_wdi_miso                =>  reg_wdi_miso,
--     reg_unb_system_info_mosi    =>  reg_unb_system_info_mosi,
--     reg_unb_system_info_miso    =>  reg_unb_system_info_miso,
--     rom_unb_system_info_mosi    =>  rom_unb_system_info_mosi,
--     rom_unb_system_info_miso    =>  rom_unb_system_info_miso,
--     reg_unb_sens_mosi           =>  reg_unb_sens_mosi,
--     reg_unb_sens_miso           =>  reg_unb_sens_miso,
--     reg_ppsh_mosi               =>  reg_ppsh_mosi,
--     reg_ppsh_miso               =>  reg_ppsh_miso,
--     eth1g_tse_clk               =>  eth1g_tse_clk,
--     eth1g_mm_rst                =>  eth1g_mm_rst,
--     eth1g_reg_interrupt         =>  eth1g_reg_interrupt,
--     eth1g_ram_mosi              =>  eth1g_ram_mosi,
--     eth1g_ram_miso              =>  eth1g_ram_miso,
--     eth1g_reg_mosi              =>  eth1g_reg_mosi,
--     eth1g_reg_miso              =>  eth1g_reg_miso,
--     eth1g_tse_mosi              =>  eth1g_tse_mosi,
--     eth1g_tse_miso              =>  eth1g_tse_miso,
--     reg_diag_data_buf_mosi      =>  reg_diag_data_buf_mosi,
--     reg_diag_data_buf_miso      =>  reg_diag_data_buf_miso,
--     ram_diag_data_buf_mosi      =>  ram_diag_data_buf_mosi,
--     ram_diag_data_buf_miso      =>  ram_diag_data_buf_miso,
--     reg_diag_bg_mosi            =>  reg_diag_bg_mosi,
--     reg_diag_bg_miso            =>  reg_diag_bg_miso,
--     ram_diag_bg_mosi            =>  ram_diag_bg_mosi,
--     ram_diag_bg_miso            =>  ram_diag_bg_miso,
--     reg_diagnostics_mosi        =>  reg_diagnostics_mosi,
--     reg_diagnostics_miso        =>  reg_diagnostics_miso,
--     reg_tr_nonbonded_mosi       =>  reg_tr_nonbonded_mosi,
--     reg_tr_nonbonded_miso       =>  reg_tr_nonbonded_miso,
--     ram_mesh_diag_data_buf_mosi =>  ram_mesh_diag_data_buf_mosi,
--     ram_mesh_diag_data_buf_miso =>  ram_mesh_diag_data_buf_miso,
--     reg_bsn_monitor_mosi        =>  reg_bsn_monitor_mosi,
--     reg_bsn_monitor_miso        =>  reg_bsn_monitor_miso
--   );
-- 
LIBRARY IEEE, common_lib, unb1_board_lib, mm_lib, eth_lib, technology_lib, tech_tse_lib;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.NUMERIC_STD.ALL;
USE common_lib.common_pkg.ALL;
USE common_lib.common_mem_pkg.ALL;
USE common_lib.tb_common_mem_pkg.ALL;
USE common_lib.common_field_pkg.ALL;
USE common_lib.common_network_total_header_pkg.ALL;
USE common_lib.common_network_layers_pkg.ALL;
USE common_lib.common_mem_pkg.ALL;
USE unb1_board_lib.unb1_board_pkg.ALL;
USE unb1_board_lib.unb1_board_peripherals_pkg.ALL;
USE mm_lib.mm_file_pkg.ALL;
USE mm_lib.mm_file_unb_pkg.ALL;
USE eth_lib.eth_pkg.ALL;
USE technology_lib.technology_pkg.ALL;
USE tech_tse_lib.tech_tse_pkg.ALL;
USE tech_tse_lib.tb_tech_tse_pkg.ALL;

ENTITY mmm_unb1_terminal_bg_mesh_db IS
  GENERIC (
    g_sim         : BOOLEAN := FALSE;
    g_sim_unb_nr  : NATURAL := 0;
    g_sim_node_nr : NATURAL := 0
  );
  PORT (
    mm_clk                      : IN  STD_LOGIC := '1';
    mm_rst                      : IN  STD_LOGIC := '1';
    pout_wdi                    : OUT STD_LOGIC := '1';
    reg_wdi_mosi                : OUT t_mem_mosi;
    reg_wdi_miso                : IN  t_mem_miso := c_mem_miso_rst;
    reg_unb_system_info_mosi    : OUT t_mem_mosi;
    reg_unb_system_info_miso    : IN  t_mem_miso := c_mem_miso_rst;
    rom_unb_system_info_mosi    : OUT t_mem_mosi;
    rom_unb_system_info_miso    : IN  t_mem_miso := c_mem_miso_rst;
    reg_unb_sens_mosi           : OUT t_mem_mosi;
    reg_unb_sens_miso           : IN  t_mem_miso := c_mem_miso_rst;
    reg_ppsh_mosi               : OUT t_mem_mosi;
    reg_ppsh_miso               : IN  t_mem_miso := c_mem_miso_rst;
    eth1g_tse_clk               : OUT STD_LOGIC;
    eth1g_mm_rst                : OUT STD_LOGIC;
    eth1g_reg_interrupt         : IN  STD_LOGIC;
    eth1g_ram_mosi              : OUT t_mem_mosi;
    eth1g_ram_miso              : IN  t_mem_miso := c_mem_miso_rst;
    eth1g_reg_mosi              : OUT t_mem_mosi;
    eth1g_reg_miso              : IN  t_mem_miso := c_mem_miso_rst;
    eth1g_tse_mosi              : OUT t_mem_mosi;
    eth1g_tse_miso              : IN  t_mem_miso := c_mem_miso_rst;
    reg_diag_data_buf_mosi      : OUT t_mem_mosi;
    reg_diag_data_buf_miso      : IN  t_mem_miso := c_mem_miso_rst;
    ram_diag_data_buf_mosi      : OUT t_mem_mosi;
    ram_diag_data_buf_miso      : IN  t_mem_miso := c_mem_miso_rst;
    reg_diag_bg_mosi            : OUT t_mem_mosi;
    reg_diag_bg_miso            : IN  t_mem_miso := c_mem_miso_rst;
    ram_diag_bg_mosi            : OUT t_mem_mosi;
    ram_diag_bg_miso            : IN  t_mem_miso := c_mem_miso_rst;
    reg_diagnostics_mosi        : OUT t_mem_mosi;
    reg_diagnostics_miso        : IN  t_mem_miso := c_mem_miso_rst;
    reg_tr_nonbonded_mosi       : OUT t_mem_mosi;
    reg_tr_nonbonded_miso       : IN  t_mem_miso := c_mem_miso_rst;
    ram_mesh_diag_data_buf_mosi : OUT t_mem_mosi;
    ram_mesh_diag_data_buf_miso : IN  t_mem_miso := c_mem_miso_rst;
    reg_bsn_monitor_mosi        : OUT t_mem_mosi;
    reg_bsn_monitor_miso        : IN  t_mem_miso := c_mem_miso_rst
  );
END ENTITY mmm_unb1_terminal_bg_mesh_db;

ARCHITECTURE str OF mmm_unb1_terminal_bg_mesh_db IS

  CONSTANT c_sim_node_type         : STRING(1 TO 2)                                := sel_a_b(g_sim_node_nr<4, "FN", "BN");
  CONSTANT c_sim_node_nr           : NATURAL                                       := sel_a_b(c_sim_node_type="BN", g_sim_node_nr-4, g_sim_node_nr);
  CONSTANT c_sim_eth_src_mac       : STD_LOGIC_VECTOR(c_network_eth_mac_slv'RANGE) := X"00228608" & TO_UVEC(g_sim_unb_nr, c_byte_w) & TO_UVEC(g_sim_node_nr, c_byte_w);
  CONSTANT c_sim_eth_control_rx_en : NATURAL                                       := 2**c_eth_mm_reg_control_bi.rx_en;

  SIGNAL sim_eth_mm_bus_switch : STD_LOGIC ;
  SIGNAL sim_eth_psc_access    : STD_LOGIC ;
  SIGNAL i_eth1g_reg_mosi      : t_mem_mosi;
  SIGNAL i_eth1g_reg_miso      : t_mem_miso;
  SIGNAL sim_eth1g_reg_mosi    : t_mem_mosi;

  COMPONENT mm_file IS
    GENERIC (
      g_file_prefix      : STRING ;
      g_mm_clk_period    : TIME    := 8 ns;
      g_update_on_change : BOOLEAN := FALSE;
      g_mm_rd_latency    : NATURAL := 1
    );
    PORT (
      mm_rst        : IN  STD_LOGIC;
      mm_clk        : IN  STD_LOGIC;
      mm_master_out : OUT t_mem_mosi := c_mem_mosi_rst;
      mm_master_in  : IN  t_mem_miso := c_mem_miso_rst
    );
  END COMPONENT mm_file;
  
  COMPONENT qsys_unb1_terminal_bg_mesh_db IS
    PORT (
      reg_diag_bg_reset_export                : out std_logic;
      ram_diag_bg_read_export                 : out std_logic;
      ram_diag_data_buf_readdata_export       : in  std_logic_vector(31 downto 0) := (others => '0');
      eth1g_reg_readdata_export               : in  std_logic_vector(31 downto 0) := (others => '0');
      reset_in_reset_n                        : in  std_logic := '0';
      reg_diagnostics_write_export            : out std_logic;
      pio_pps_address_export                  : out std_logic;
      pio_system_info_address_export          : out std_logic_vector(4 downto 0);
      reg_diag_data_buf_write_export          : out std_logic;
      pio_pps_reset_export                    : out std_logic;
      ram_mesh_diag_data_buf_readdata_export  : in  std_logic_vector(31 downto 0) := (others => '0');
      eth1g_tse_writedata_export              : out std_logic_vector(31 downto 0);
      ram_mesh_diag_data_buf_reset_export     : out std_logic;
      eth1g_ram_readdata_export               : in  std_logic_vector(31 downto 0) := (others => '0');
      ram_diag_data_buf_address_export        : out std_logic_vector(13 downto 0);
      eth1g_ram_address_export                : out std_logic_vector(9 downto 0);
      pio_pps_readdata_export                 : in  std_logic_vector(31 downto 0) := (others => '0');
      reg_diag_data_buf_address_export        : out std_logic;
      reg_diag_bg_writedata_export            : out std_logic_vector(31 downto 0);
      pio_system_info_writedata_export        : out std_logic_vector(31 downto 0);
      eth1g_reg_writedata_export              : out std_logic_vector(31 downto 0);
      reg_unb_sens_reset_export               : out std_logic;
      eth1g_tse_address_export                : out std_logic_vector(9 downto 0);
      reg_wdi_reset_export                    : out std_logic;
      clk_in_clk                              : in  std_logic := '0';
      rom_system_info_clk_export              : out std_logic;
      reg_unb_sens_read_export                : out std_logic;
      reg_unb_sens_write_export               : out std_logic;
      reg_diag_data_buf_readdata_export       : in  std_logic_vector(31 downto 0) := (others => '0');
      ram_diag_bg_reset_export                : out std_logic;
      reg_diag_data_buf_writedata_export      : out std_logic_vector(31 downto 0);
      reg_diag_data_buf_read_export           : out std_logic;
      eth1g_tse_readdata_export               : in  std_logic_vector(31 downto 0) := (others => '0');
      eth1g_ram_write_export                  : out std_logic;
      reg_diagnostics_writedata_export        : out std_logic_vector(31 downto 0);
      reg_unb_sens_clk_export                 : out std_logic;
      reg_tr_nonbonded_clk_export             : out std_logic;
      ram_mesh_diag_data_buf_clk_export       : out std_logic;
      ram_diag_bg_write_export                : out std_logic;
      ram_diag_bg_address_export              : out std_logic_vector(10 downto 0);
      ram_mesh_diag_data_buf_writedata_export : out std_logic_vector(31 downto 0);
      reg_wdi_read_export                     : out std_logic;
      eth1g_ram_read_export                   : out std_logic;
      eth1g_reg_read_export                   : out std_logic;
      ram_diag_bg_writedata_export            : out std_logic_vector(31 downto 0);
      reg_bsn_monitor_reset_export            : out std_logic;
      eth1g_tse_write_export                  : out std_logic;
      reg_unb_sens_readdata_export            : in  std_logic_vector(31 downto 0) := (others => '0');
      reg_bsn_monitor_write_export            : out std_logic;
      ram_mesh_diag_data_buf_address_export   : out std_logic_vector(13 downto 0);
      pio_pps_clk_export                      : out std_logic;
      eth1g_reg_address_export                : out std_logic_vector(3 downto 0);
      reg_diag_bg_address_export              : out std_logic_vector(2 downto 0);
      pio_system_info_readdata_export         : in  std_logic_vector(31 downto 0) := (others => '0');
      rom_system_info_writedata_export        : out std_logic_vector(31 downto 0);
      reg_tr_nonbonded_reset_export           : out std_logic;
      ram_mesh_diag_data_buf_read_export      : out std_logic;
      reg_bsn_monitor_read_export             : out std_logic;
      reg_tr_nonbonded_address_export         : out std_logic_vector(3 downto 0);
      reg_wdi_address_export                  : out std_logic;
      reg_diag_bg_clk_export                  : out std_logic;
      pio_system_info_write_export            : out std_logic;
      reg_tr_nonbonded_writedata_export       : out std_logic_vector(31 downto 0);
      reg_tr_nonbonded_write_export           : out std_logic;
      pio_pps_write_export                    : out std_logic;
      rom_system_info_write_export            : out std_logic;
      ram_diag_data_buf_writedata_export      : out std_logic_vector(31 downto 0);
      rom_system_info_read_export             : out std_logic;
      reg_diagnostics_address_export          : out std_logic_vector(5 downto 0);
      ram_diag_data_buf_write_export          : out std_logic;
      reg_tr_nonbonded_readdata_export        : in  std_logic_vector(31 downto 0) := (others => '0');
      reg_diag_data_buf_clk_export            : out std_logic;
      reg_diag_bg_read_export                 : out std_logic;
      ram_diag_data_buf_reset_export          : out std_logic;
      eth1g_tse_read_export                   : out std_logic;
      ram_diag_bg_clk_export                  : out std_logic;
      reg_unb_sens_writedata_export           : out std_logic_vector(31 downto 0);
      eth1g_ram_writedata_export              : out std_logic_vector(31 downto 0);
      reg_tr_nonbonded_read_export            : out std_logic;
      out_port_from_the_pio_debug_wave        : out std_logic_vector(31 downto 0);
      pio_system_info_reset_export            : out std_logic;
      reg_wdi_writedata_export                : out std_logic_vector(31 downto 0);
      reg_diag_data_buf_reset_export          : out std_logic;
      reg_bsn_monitor_writedata_export        : out std_logic_vector(31 downto 0);
      pio_system_info_read_export             : out std_logic;
      reg_bsn_monitor_address_export          : out std_logic_vector(6 downto 0);
      ram_diag_data_buf_clk_export            : out std_logic;
      ram_diag_data_buf_read_export           : out std_logic;
      reg_wdi_clk_export                      : out std_logic;
      reg_diag_bg_write_export                : out std_logic;
      reg_diagnostics_read_export             : out std_logic;
      eth1g_mm_rst_export                     : out std_logic;
      reg_diagnostics_reset_export            : out std_logic;
      out_port_from_the_pio_wdi               : out std_logic;
      reg_bsn_monitor_clk_export              : out std_logic;
      eth1g_reg_write_export                  : out std_logic;
      reg_diag_bg_readdata_export             : in  std_logic_vector(31 downto 0) := (others => '0');
      rom_system_info_readdata_export         : in  std_logic_vector(31 downto 0) := (others => '0');
      reg_wdi_write_export                    : out std_logic;
      reg_wdi_readdata_export                 : in  std_logic_vector(31 downto 0) := (others => '0');
      pio_pps_read_export                     : out std_logic;
      pio_system_info_clk_export              : out std_logic;
      ram_mesh_diag_data_buf_write_export     : out std_logic;
      pio_pps_writedata_export                : out std_logic_vector(31 downto 0);
      eth1g_tse_waitrequest_export            : in  std_logic := '0';
      reg_bsn_monitor_readdata_export         : in  std_logic_vector(31 downto 0) := (others => '0');
      eth1g_mm_clk_export                     : out std_logic;
      rom_system_info_reset_export            : out std_logic;
      reg_unb_sens_address_export             : out std_logic_vector(2 downto 0);
      rom_system_info_address_export          : out std_logic_vector(9 downto 0);
      eth1g_irq_export                        : in  std_logic := '0';
      reg_diagnostics_readdata_export         : in  std_logic_vector(31 downto 0) := (others => '0');
      ram_diag_bg_readdata_export             : in  std_logic_vector(31 downto 0) := (others => '0');
      reg_diagnostics_clk_export              : out std_logic
    );
  END COMPONENT qsys_unb1_terminal_bg_mesh_db;
  

BEGIN

  ----------------------------------------------------------------------------
  -- MM <-> file I/O for simulation. The files are created in $UPE/sim.
  ----------------------------------------------------------------------------
  gen_mm_file_io : IF g_sim = TRUE GENERATE
    u_mm_file_reg_wdi  :  mm_file GENERIC MAP(mmf_unb_file_prefix(g_sim_unb_nr, c_sim_node_nr, c_sim_node_type) & "REG_WDI")
          PORT MAP(mm_rst, mm_clk, reg_wdi_mosi, reg_wdi_miso );
    u_mm_file_reg_unb_system_info  :  mm_file GENERIC MAP(mmf_unb_file_prefix(g_sim_unb_nr, c_sim_node_nr, c_sim_node_type) & "PIO_SYSTEM_INFO")
          PORT MAP(mm_rst, mm_clk, reg_unb_system_info_mosi, reg_unb_system_info_miso );
    u_mm_file_rom_unb_system_info  :  mm_file GENERIC MAP(mmf_unb_file_prefix(g_sim_unb_nr, c_sim_node_nr, c_sim_node_type) & "ROM_SYSTEM_INFO")
          PORT MAP(mm_rst, mm_clk, rom_unb_system_info_mosi, rom_unb_system_info_miso );
    u_mm_file_reg_unb_sens  :  mm_file GENERIC MAP(mmf_unb_file_prefix(g_sim_unb_nr, c_sim_node_nr, c_sim_node_type) & "REG_UNB_SENS")
          PORT MAP(mm_rst, mm_clk, reg_unb_sens_mosi, reg_unb_sens_miso );
    u_mm_file_reg_ppsh  :  mm_file GENERIC MAP(mmf_unb_file_prefix(g_sim_unb_nr, c_sim_node_nr, c_sim_node_type) & "PIO_PPS")
          PORT MAP(mm_rst, mm_clk, reg_ppsh_mosi, reg_ppsh_miso );
    u_mm_file_eth1g_ram  :  mm_file GENERIC MAP(mmf_unb_file_prefix(g_sim_unb_nr, c_sim_node_nr, c_sim_node_type) & "ETH1G_RAM")
          PORT MAP(mm_rst, mm_clk, eth1g_ram_mosi, eth1g_ram_miso );
    u_mm_file_eth1g_reg  :  mm_file GENERIC MAP(mmf_unb_file_prefix(g_sim_unb_nr, c_sim_node_nr, c_sim_node_type) & "AVS_ETH_0_MMS_REG")
          PORT MAP(mm_rst, mm_clk, eth1g_reg_mosi, eth1g_reg_miso );
    u_mm_file_eth1g_tse  :  mm_file GENERIC MAP(mmf_unb_file_prefix(g_sim_unb_nr, c_sim_node_nr, c_sim_node_type) & "ETH1G_TSE")
          PORT MAP(mm_rst, mm_clk, eth1g_tse_mosi, eth1g_tse_miso );
    u_mm_file_reg_diag_data_buf  :  mm_file GENERIC MAP(mmf_unb_file_prefix(g_sim_unb_nr, c_sim_node_nr, c_sim_node_type) & "REG_DIAG_DATA_BUF")
          PORT MAP(mm_rst, mm_clk, reg_diag_data_buf_mosi, reg_diag_data_buf_miso );
    u_mm_file_reg_diag_bg  :  mm_file GENERIC MAP(mmf_unb_file_prefix(g_sim_unb_nr, c_sim_node_nr, c_sim_node_type) & "REG_DIAG_BG")
          PORT MAP(mm_rst, mm_clk, reg_diag_bg_mosi, reg_diag_bg_miso );
    u_mm_file_reg_diagnostics  :  mm_file GENERIC MAP(mmf_unb_file_prefix(g_sim_unb_nr, c_sim_node_nr, c_sim_node_type) & "REG_DIAGNOSTICS")
          PORT MAP(mm_rst, mm_clk, reg_diagnostics_mosi, reg_diagnostics_miso );
    u_mm_file_reg_tr_nonbonded  :  mm_file GENERIC MAP(mmf_unb_file_prefix(g_sim_unb_nr, c_sim_node_nr, c_sim_node_type) & "REG_TR_NONBONDED")
          PORT MAP(mm_rst, mm_clk, reg_tr_nonbonded_mosi, reg_tr_nonbonded_miso );
    u_mm_file_reg_bsn_monitor  :  mm_file GENERIC MAP(mmf_unb_file_prefix(g_sim_unb_nr, c_sim_node_nr, c_sim_node_type) & "REG_BSN_MONITOR")
          PORT MAP(mm_rst, mm_clk, reg_bsn_monitor_mosi, reg_bsn_monitor_miso );
    ----------------------------------------------------------------------------
    -- 1GbE setup sequence normally performed by unb_os@NIOS
    ----------------------------------------------------------------------------
    p_eth_setup : PROCESS
    BEGIN
      sim_eth_mm_bus_switch <= '1';
      eth1g_tse_mosi.wr <= '0';
      eth1g_tse_mosi.rd <= '0';
      WAIT FOR 400 ns;
      WAIT UNTIL rising_edge(mm_clk);
      proc_tech_tse_setup(c_tech_stratixiv, FALSE, c_tech_tse_tx_fifo_depth, c_tech_tse_rx_fifo_depth, c_tech_tse_tx_ready_latency, c_sim_eth_src_mac, sim_eth_psc_access, mm_clk, eth1g_tse_miso, eth1g_tse_mosi);
      -- Enable RX
      proc_mem_mm_bus_wr(c_eth_reg_control_wi+0, c_sim_eth_control_rx_en, mm_clk, eth1g_reg_miso, sim_eth1g_reg_mosi);  -- control rx en
      sim_eth_mm_bus_switch <= '0';
      WAIT;
    END PROCESS;
    
    p_switch : PROCESS(sim_eth_mm_bus_switch, sim_eth1g_reg_mosi, i_eth1g_reg_mosi)
    BEGIN
      IF sim_eth_mm_bus_switch = '1' THEN
        eth1g_reg_mosi <= sim_eth1g_reg_mosi;
      ELSE
        eth1g_reg_mosi <= i_eth1g_reg_mosi;
      END IF;
    END PROCESS;
    ----------------------------------------------------------------------------
    -- Procedure that polls a sim control file that can be used to e.g. get
    -- the simulation time in ns
    ----------------------------------------------------------------------------
    mmf_poll_sim_ctrl_file(c_mmf_unb_file_path & "sim.ctrl", c_mmf_unb_file_path & "sim.stat");
    
  END GENERATE;
  ----------------------------------------------------------------------------
  -- SOPC or QSYS for synthesis
  ----------------------------------------------------------------------------
  gen_qsys_unb1_terminal_bg_mesh_db : IF g_sim = FALSE GENERATE
    u_qsys_unb1_terminal_bg_mesh_db : qsys_unb1_terminal_bg_mesh_db
      PORT MAP(
      clk_in_clk                              => mm_clk,
      eth1g_irq_export                        => eth1g_reg_interrupt,
      eth1g_mm_clk_export                     => OPEN,
      eth1g_mm_rst_export                     => eth1g_mm_rst,
      eth1g_ram_address_export                => eth1g_ram_mosi.address(9 DOWNTO 0),
      eth1g_ram_read_export                   => eth1g_ram_mosi.rd,
      eth1g_ram_readdata_export               => eth1g_ram_miso.rddata(c_word_w-1 DOWNTO 0),
      eth1g_ram_write_export                  => eth1g_ram_mosi.wr,
      eth1g_ram_writedata_export              => eth1g_ram_mosi.wrdata(c_word_w-1 DOWNTO 0),
      eth1g_reg_address_export                => eth1g_reg_mosi.address(3 DOWNTO 0),
      eth1g_reg_read_export                   => eth1g_reg_mosi.rd,
      eth1g_reg_readdata_export               => eth1g_reg_miso.rddata(c_word_w-1 DOWNTO 0),
      eth1g_reg_write_export                  => eth1g_reg_mosi.wr,
      eth1g_reg_writedata_export              => eth1g_reg_mosi.wrdata(c_word_w-1 DOWNTO 0),
      eth1g_tse_address_export                => eth1g_tse_mosi.address(9 DOWNTO 0),
      eth1g_tse_read_export                   => eth1g_tse_mosi.rd,
      eth1g_tse_readdata_export               => eth1g_tse_miso.rddata(c_word_w-1 DOWNTO 0),
      eth1g_tse_waitrequest_export            => eth1g_tse_miso.waitrequest,
      eth1g_tse_write_export                  => eth1g_tse_mosi.wr,
      eth1g_tse_writedata_export              => eth1g_tse_mosi.wrdata(c_word_w-1 DOWNTO 0),
      out_port_from_the_pio_debug_wave        => OPEN,
      out_port_from_the_pio_wdi               => pout_wdi,
      pio_pps_address_export                  => reg_ppsh_mosi.address(0),
      pio_pps_clk_export                      => OPEN,
      pio_pps_read_export                     => reg_ppsh_mosi.rd,
      pio_pps_readdata_export                 => reg_ppsh_miso.rddata(c_word_w-1 DOWNTO 0),
      pio_pps_reset_export                    => OPEN,
      pio_pps_write_export                    => reg_ppsh_mosi.wr,
      pio_pps_writedata_export                => reg_ppsh_mosi.wrdata(c_word_w-1 DOWNTO 0),
      pio_system_info_address_export          => reg_unb_system_info_mosi.address(4 DOWNTO 0),
      pio_system_info_clk_export              => OPEN,
      pio_system_info_read_export             => reg_unb_system_info_mosi.rd,
      pio_system_info_readdata_export         => reg_unb_system_info_miso.rddata(c_word_w-1 DOWNTO 0),
      pio_system_info_reset_export            => OPEN,
      pio_system_info_write_export            => reg_unb_system_info_mosi.wr,
      pio_system_info_writedata_export        => reg_unb_system_info_mosi.wrdata(c_word_w-1 DOWNTO 0),
      ram_diag_bg_address_export              => ram_diag_bg_mosi.address(10 DOWNTO 0),
      ram_diag_bg_clk_export                  => OPEN,
      ram_diag_bg_read_export                 => ram_diag_bg_mosi.rd,
      ram_diag_bg_readdata_export             => ram_diag_bg_miso.rddata(c_word_w-1 DOWNTO 0),
      ram_diag_bg_reset_export                => OPEN,
      ram_diag_bg_write_export                => ram_diag_bg_mosi.wr,
      ram_diag_bg_writedata_export            => ram_diag_bg_mosi.wrdata(c_word_w-1 DOWNTO 0),
      ram_diag_data_buf_address_export        => ram_diag_data_buf_mosi.address(13 DOWNTO 0),
      ram_diag_data_buf_clk_export            => OPEN,
      ram_diag_data_buf_read_export           => ram_diag_data_buf_mosi.rd,
      ram_diag_data_buf_readdata_export       => ram_diag_data_buf_miso.rddata(c_word_w-1 DOWNTO 0),
      ram_diag_data_buf_reset_export          => OPEN,
      ram_diag_data_buf_write_export          => ram_diag_data_buf_mosi.wr,
      ram_diag_data_buf_writedata_export      => ram_diag_data_buf_mosi.wrdata(c_word_w-1 DOWNTO 0),
      ram_mesh_diag_data_buf_address_export   => ram_mesh_diag_data_buf_mosi.address(13 DOWNTO 0),
      ram_mesh_diag_data_buf_clk_export       => OPEN,
      ram_mesh_diag_data_buf_read_export      => ram_mesh_diag_data_buf_mosi.rd,
      ram_mesh_diag_data_buf_readdata_export  => ram_mesh_diag_data_buf_miso.rddata(c_word_w-1 DOWNTO 0),
      ram_mesh_diag_data_buf_reset_export     => OPEN,
      ram_mesh_diag_data_buf_write_export     => ram_mesh_diag_data_buf_mosi.wr,
      ram_mesh_diag_data_buf_writedata_export => ram_mesh_diag_data_buf_mosi.wrdata(c_word_w-1 DOWNTO 0),
      reg_bsn_monitor_address_export          => reg_bsn_monitor_mosi.address(6 DOWNTO 0),
      reg_bsn_monitor_clk_export              => OPEN,
      reg_bsn_monitor_read_export             => reg_bsn_monitor_mosi.rd,
      reg_bsn_monitor_readdata_export         => reg_bsn_monitor_miso.rddata(c_word_w-1 DOWNTO 0),
      reg_bsn_monitor_reset_export            => OPEN,
      reg_bsn_monitor_write_export            => reg_bsn_monitor_mosi.wr,
      reg_bsn_monitor_writedata_export        => reg_bsn_monitor_mosi.wrdata(c_word_w-1 DOWNTO 0),
      reg_diag_bg_address_export              => reg_diag_bg_mosi.address(2 DOWNTO 0),
      reg_diag_bg_clk_export                  => OPEN,
      reg_diag_bg_read_export                 => reg_diag_bg_mosi.rd,
      reg_diag_bg_readdata_export             => reg_diag_bg_miso.rddata(c_word_w-1 DOWNTO 0),
      reg_diag_bg_reset_export                => OPEN,
      reg_diag_bg_write_export                => reg_diag_bg_mosi.wr,
      reg_diag_bg_writedata_export            => reg_diag_bg_mosi.wrdata(c_word_w-1 DOWNTO 0),
      reg_diag_data_buf_address_export        => reg_diag_data_buf_mosi.address(0),
      reg_diag_data_buf_clk_export            => OPEN,
      reg_diag_data_buf_read_export           => reg_diag_data_buf_mosi.rd,
      reg_diag_data_buf_readdata_export       => reg_diag_data_buf_miso.rddata(c_word_w-1 DOWNTO 0),
      reg_diag_data_buf_reset_export          => OPEN,
      reg_diag_data_buf_write_export          => reg_diag_data_buf_mosi.wr,
      reg_diag_data_buf_writedata_export      => reg_diag_data_buf_mosi.wrdata(c_word_w-1 DOWNTO 0),
      reg_diagnostics_address_export          => reg_diagnostics_mosi.address(5 DOWNTO 0),
      reg_diagnostics_clk_export              => OPEN,
      reg_diagnostics_read_export             => reg_diagnostics_mosi.rd,
      reg_diagnostics_readdata_export         => reg_diagnostics_miso.rddata(c_word_w-1 DOWNTO 0),
      reg_diagnostics_reset_export            => OPEN,
      reg_diagnostics_write_export            => reg_diagnostics_mosi.wr,
      reg_diagnostics_writedata_export        => reg_diagnostics_mosi.wrdata(c_word_w-1 DOWNTO 0),
      reg_tr_nonbonded_address_export         => reg_tr_nonbonded_mosi.address(3 DOWNTO 0),
      reg_tr_nonbonded_clk_export             => OPEN,
      reg_tr_nonbonded_read_export            => reg_tr_nonbonded_mosi.rd,
      reg_tr_nonbonded_readdata_export        => reg_tr_nonbonded_miso.rddata(c_word_w-1 DOWNTO 0),
      reg_tr_nonbonded_reset_export           => OPEN,
      reg_tr_nonbonded_write_export           => reg_tr_nonbonded_mosi.wr,
      reg_tr_nonbonded_writedata_export       => reg_tr_nonbonded_mosi.wrdata(c_word_w-1 DOWNTO 0),
      reg_unb_sens_address_export             => reg_unb_sens_mosi.address(2 DOWNTO 0),
      reg_unb_sens_clk_export                 => OPEN,
      reg_unb_sens_read_export                => reg_unb_sens_mosi.rd,
      reg_unb_sens_readdata_export            => reg_unb_sens_miso.rddata(c_word_w-1 DOWNTO 0),
      reg_unb_sens_reset_export               => OPEN,
      reg_unb_sens_write_export               => reg_unb_sens_mosi.wr,
      reg_unb_sens_writedata_export           => reg_unb_sens_mosi.wrdata(c_word_w-1 DOWNTO 0),
      reg_wdi_address_export                  => reg_wdi_mosi.address(0),
      reg_wdi_clk_export                      => OPEN,
      reg_wdi_read_export                     => reg_wdi_mosi.rd,
      reg_wdi_readdata_export                 => reg_wdi_miso.rddata(c_word_w-1 DOWNTO 0),
      reg_wdi_reset_export                    => OPEN,
      reg_wdi_write_export                    => reg_wdi_mosi.wr,
      reg_wdi_writedata_export                => reg_wdi_mosi.wrdata(c_word_w-1 DOWNTO 0),
      reset_in_reset_n                        => mm_rst,
      rom_system_info_address_export          => rom_unb_system_info_mosi.address(9 DOWNTO 0),
      rom_system_info_clk_export              => OPEN,
      rom_system_info_read_export             => rom_unb_system_info_mosi.rd,
      rom_system_info_readdata_export         => rom_unb_system_info_miso.rddata(c_word_w-1 DOWNTO 0),
      rom_system_info_reset_export            => OPEN,
      rom_system_info_write_export            => rom_unb_system_info_mosi.wr,
      rom_system_info_writedata_export        => rom_unb_system_info_mosi.wrdata(c_word_w-1 DOWNTO 0)
    );
  END GENERATE;
  
END str;
