-------------------------------------------------------------------------------
--
-- Copyright (C) 2010
-- ASTRON (Netherlands Institute for Radio Astronomy) <http://www.astron.nl/>
-- JIVE (Joint Institute for VLBI in Europe) <http://www.jive.nl/>
-- P.O.Box 2, 7990 AA Dwingeloo, The Netherlands
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-------------------------------------------------------------------------------

LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;


ENTITY tb_tb_dp_fifo_sc IS
END tb_tb_dp_fifo_sc;


ARCHITECTURE tb OF tb_tb_dp_fifo_sc IS
BEGIN

  -- > as 5
  -- > run -a --> OK

  -- -- Try FIFO settings
  -- g_dut_use_lut        : BOOLEAN := FALSE;  -- when TRUE then force using LUTs instead of block RAM
  -- g_dut_fifo_size      : NATURAL := 64;
  -- g_dut_fifo_af_margin : NATURAL := 4;     -- >=4, Nof words below max (full) at which fifo is considered almost full
  -- g_dut_use_bsn        : BOOLEAN := TRUE;
  -- g_dut_use_empty      : BOOLEAN := TRUE;
  -- g_dut_use_channel    : BOOLEAN := TRUE;
  -- g_dut_use_sync       : BOOLEAN := TRUE;
  -- g_dut_use_ctrl       : BOOLEAN := TRUE;
  -- g_dut_out_latency    : NATURAL := 0       -- selectable for dp_fifo_sc: default 1 or 0 for look ahead FIFO

  u_ram_use_all_rl_0          : ENTITY work.tb_dp_fifo_sc GENERIC MAP (FALSE, 64, 4, TRUE,  TRUE,  TRUE,  TRUE,  TRUE, 0);
  u_ram_use_all               : ENTITY work.tb_dp_fifo_sc GENERIC MAP (FALSE, 64, 4, TRUE,  TRUE,  TRUE,  TRUE,  TRUE, 1);
  
  u_ram_use_ctrl_rl_0         : ENTITY work.tb_dp_fifo_sc GENERIC MAP (FALSE, 16, 4, FALSE, FALSE, FALSE, FALSE,  TRUE, 0);
  u_ram_use_ctrl              : ENTITY work.tb_dp_fifo_sc GENERIC MAP (FALSE, 16, 4, FALSE, FALSE, FALSE, FALSE,  TRUE, 1);
  
  u_lut_use_ctrl_rl_0         : ENTITY work.tb_dp_fifo_sc GENERIC MAP ( TRUE, 16, 4, FALSE, FALSE, FALSE, FALSE,  TRUE, 0);
  u_lut_use_ctrl              : ENTITY work.tb_dp_fifo_sc GENERIC MAP ( TRUE, 16, 4, FALSE, FALSE, FALSE, FALSE,  TRUE, 1);
  
  u_lut_small_use_ctrl_rl_0   : ENTITY work.tb_dp_fifo_sc GENERIC MAP ( TRUE,  8, 4, FALSE, FALSE, FALSE, FALSE,  TRUE, 0);
  u_lut_small_use_ctrl        : ENTITY work.tb_dp_fifo_sc GENERIC MAP ( TRUE,  8, 4, FALSE, FALSE, FALSE, FALSE,  TRUE, 1);
  
  u_ram_no_bsn                : ENTITY work.tb_dp_fifo_sc GENERIC MAP (FALSE, 64, 4, FALSE,  TRUE,  TRUE,  TRUE,  TRUE, 1);
  u_ram_no_empty              : ENTITY work.tb_dp_fifo_sc GENERIC MAP (FALSE, 64, 4,  TRUE, FALSE,  TRUE,  TRUE,  TRUE, 1);
  u_ram_no_channel            : ENTITY work.tb_dp_fifo_sc GENERIC MAP (FALSE, 64, 4,  TRUE,  TRUE, FALSE,  TRUE,  TRUE, 1);
  u_ram_no_sync               : ENTITY work.tb_dp_fifo_sc GENERIC MAP (FALSE, 64, 4,  TRUE,  TRUE,  TRUE, FALSE,  TRUE, 1);
  u_ram_no_ctrl               : ENTITY work.tb_dp_fifo_sc GENERIC MAP (FALSE, 64, 4,  TRUE,  TRUE,  TRUE,  TRUE, FALSE, 1);
  
END tb;
