#!/bin/bash
# -------------------------------------------------------------------------- #
#
# Copyright (C) 2014                                                        
# ASTRON (Netherlands Institute for Radio Astronomy) <http://www.astron.nl/>
# JIVE (Joint Institute for VLBI in Europe) <http://www.jive.nl/>           
# P.O.Box 2, 7990 AA Dwingeloo, The Netherlands                             
#                                                                           
# This program is free software: you can redistribute it and/or modify      
# it under the terms of the GNU General Public License as published by      
# the Free Software Foundation, either version 3 of the License, or         
# (at your option) any later version.                                       
#                                                                           
# This program is distributed in the hope that it will be useful,           
# but WITHOUT ANY WARRANTY; without even the implied warranty of            
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             
# GNU General Public License for more details.                              
#                                                                           
# You should have received a copy of the GNU General Public License         
# along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
# -------------------------------------------------------------------------- #
#
# Purpose: Generate ddr3 uniphy IP with MegaWizard
# Description:
#   Generate the IP in a separate generated/ subdirectory. Therefore first copy the MegaWizard variation file in the 'generated' output dir, because:
#   1) setting the output dir is not an option in the MegaWizard
#   2) The MegaWizard overwrites the variation file sometimes - we don't want that as it could be hand-modified with e.g. added generics
#
# Usage:
#
#   ./generate_ip.sh
#
# Remarks:
# . This dedicated script is derived from the generic script $UNB/Firmware/software/build/unb_mgw
#

# Tool settings for selected target "unb1" with stratixiv
. ${RADIOHDL}/tools/quartus/set_quartus unb1

# Generate IP
if ! [ -d "generated" ]; then
    mkdir generated
fi
cd generated
cp ../ip_stratixiv_ddr3_uphy_4g_single_rank_800_master.v  .

qmegawiz -silent -f:$UNB/Firmware/software/build/unb_mgw_params.txt ip_stratixiv_ddr3_uphy_4g_single_rank_800_master.v

#rm ip_stratixiv_ddr3_uphy_4g_single_rank_800_master.v
