from myhdl import *

#from astron_base import clock, reset

def dp_block_gen(src_out, snk_in, clock, reset, g_count_max):
    """ Incrementer with enable.

    g_count_max -- counter max value

    src_out -- Streaming output SOSI
    snk_in  -- flow control SISO

    clock -- clock input
    reset -- asynchronous reset input
    """

    @always_seq(clock.posedge, reset=reset)
    def incLogic():
        if snk_in.ready==1:
            src_out.data.next = (src_out.data + 1) % g_count_max
            src_out.valid.next = 1
            src_out.sop.next = 0
            src_out.eop.next = 0

            if src_out.data == 0:
                src_out.sop.next = 1
            elif src_out.data == g_count_max-1:
                src_out.eop.next = 1

    return incLogic
