from dp_stream_pkg import *
from dp_mux import dp_mux
from dp_block_gen import dp_block_gen

def dp_system(mux_src_out, reset, clock):

    mux_sel = Signal(bool(0))

    bg0_src_in = DP_SISO()
    bg1_src_in = DP_SISO()

    bg0_src_in.ready = 1
    bg1_src_in.ready = 1

    bg0_src_out = DP_SOSI(data_w=2)
    bg1_src_out = DP_SOSI(data_w=2)

    bg0 = dp_block_gen(bg0_src_out, bg0_src_in, clock, reset, g_count_max=4)
    bg1 = dp_block_gen(bg1_src_out, bg1_src_in, clock, reset, g_count_max=4)
    my_mux = dp_mux(mux_src_out, bg0_src_out, bg1_src_out, mux_sel)

    return bg0, bg1, my_mux


def convert():

    mux_src_out = DP_SOSI(data_w=2)
    clock = Signal(bool(0))
    reset = ResetSignal(0, active=0, async=True)
    toVerilog(dp_system, mux_src_out, reset, clock)
    toVHDL(dp_system, mux_src_out, reset, clock)

convert()
