from myhdl import *

def inc_comb(nextCount, count, n):

    @always(count)
    def logic():
        # do nothing here
        pass

    nextCount.driven = "wire"

    return logic

inc_comb.verilog_code =\
"""
assign $nextCount = ($count + 1) % $n;
"""

inc_comb.vhdl_code =\
"""
$nextCount <= ($count + 1) mod $n;
"""

def convert():

    nextCount = Signal(intbv(0)[8:])
    count = Signal(intbv(0)[8:])

    toVerilog(inc_comb, nextCount, count, 256 )
    toVHDL(inc_comb, nextCount, count, 256)

convert()
