#!/bin/bash
###############################################################################
#
# Copyright (C) 2014
# ASTRON (Netherlands Institute for Radio Astronomy) <http://www.astron.nl/>
# P.O.Box 2, 7990 AA Dwingeloo, The Netherlands
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Only run this script once
if [ -z "${RADIOHDL_SH}" ]; then
export RADIOHDL_SH=true
echo "Setup RadioHDL environment"

# 1) Usage

# Define $SVN in .bashrc
# Source this script in the .bashrc to setup the RadioHDL environment for Modelsim and Quartus.


# 2) Setup

export UNB=${SVN}/UniBoard/trunk
export RADIOHDL=${SVN}/RadioHDL/trunk
export HDL_BUILD_DIR=${RADIOHDL}/build

# Read generic functions/definitions
. ${UNB}/Firmware/software/build/generic.sh

# UniBoard Python Environment
export UPE=${UNB}/Software/python
export ONECLICK=${RADIOHDL}/tools/oneclick
export PYTHONPATH=${UPE}/base:${UPE}/peripherals:${UPE}/reginfo:${ONECLICK}/base

# Add search paths for executeables to $PATH
export PATH=${PATH}:\
${UPE}/base:\
${UNB}/Firmware/software/build:\
${RADIOHDL}/tools/quartus:\
${RADIOHDL}/tools/modelsim

fi
